/*
 * Po drate 4 Lemmings clone
 * Copyright (C) 2009 Jiri Benc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <stdio.h>
#include "lemmings.h"

#define EASY

#define MAX_INPUT	2048
static char input[MAX_INPUT];
static char *pos;

void get_program(void)
{
	fputs(
"Zde je mozno programovat nas hraci strojek. Pouziva specificky format vstupu,\n"
"o kterem je znamo to, ze je cten po znacich, a cokoliv, co neni cislice,\n"
"pismeno, plus nebo minus, je ignorovano.\n"
#ifdef EASY
"\n"
"Pismena jsou ctena po blocich, cteni je zastaveno na poslednim znaku pred\n"
"cislici. Nactena pismena udavaji funkce, ktere jsou prirazeny objektum.\n"
"Kazdy objekt smi mit najednou jen jednu funkci, pri pokusu o prirazeni druhe\n"
"funkce nebo neplatne funkce je prirazeni preskoceno a je pokracovano prirazenim\n"
"dalsi funkce dalsimu objektu. Funkce jsou prirazeny najednou.\n"
"\n"
"Cislice jsou rovnez cteny po blocich, jednotlive cislice jsou secteny a hraci\n"
"strojek provede prislusny pocet kroku bez prirazovani novych funkci.\n"
"\n"
"Po nacteni cislic (a provedeni prislusneho poctu kroku) jsou opet ctena\n"
"pismena, pak opet cislice, atd., dokud neni dosazeno uspesneho nebo neuspesneho\n"
"finalniho stavu, nebo prekrocen maximalni povoleny pocet kroku strojku.\n"
#endif
"\n"
"Zadej vstup (ukonceny Enterem): ", stdout);
	fflush(stdout);
	fgets(input, MAX_INPUT, stdin);
	pos = input;
}

static void skip_unknown(void)
{
	while (*pos) {
		if (*pos >= 'A' && *pos <= 'Z') {
			*pos = *pos - 'A' + 'a';
			return;
		}
		if (*pos >= 'a' && *pos <= 'z')
			return;
		if (*pos >= '1' && *pos <= '9')
			return;
		if (*pos == '+')
			adjust_speed(-1);
		else if (*pos == '-')
			adjust_speed(1);
		pos++;
	}
}

void advance_program(void)
{
	skip_unknown();
	if (*pos >= '1' && *pos <= '9')
		*pos -= 1;
}

int program_get_skill(void)
{
	int skill;

	if (*pos < 'a' || *pos > 'z')
		return -1;	// no more work in this step
	skill = *pos - 'a' + 1;
	if (skill > SKILLS)
		skill = 0;
	pos++;
	skip_unknown();
	return skill;
}
